*-----------------------------------------------------------
* Program    : Maze
* Written by : Blake Price
* Date       : April 2013
* Description: Maze game, randomly generated
*-----------------------------------------------------------
***
***
***
MAX_X 	EQU	25
MAX_Y	EQU	19
MAX_X_MONE	EQU	MAX_X-1
MAX_Y_MONE	EQU	MAX_Y-1
MAX_Y_RND	EQU	MAX_Y+1
MAZE_SIZE       EQU     MAX_X*MAX_Y-1
BOX_WIDTH	EQU	25

*Colors
BLACK	equ $00000000 
MAROON	equ $00000080 
GREEN 	equ $00008000 
OLIVE	equ $00008080 
NAVY 	equ $00800000 
PURPLE	equ $00800080 
TEAL	equ $00808000 
GRAY	equ $00808080 
RED 	equ $000000FF 
LIME 	equ $0000FF00 
YELLOW 	equ $0000FFFF 
BLUE 	equ $00FF0000 
FUCHSIA equ $00FF00FF 
AQUA 	equ $00FFFF00 
LTGRAY 	equ $00C0C0C0 
WHITE 	equ $00FFFFFF 


SET_COLOR MACRO
	MOVEM.L	D0-D1,-(SP)
	MOVE 	#80, D0
	MOVE.L 	\1, D1
	TRAP 	#15
	MOVEM.L	(SP)+,D0-D1
	ENDM
	
SET_PEN MACRO
	MOVEM.L	D0-D1,-(SP)
	MOVE 	#93, D0
	MOVE 	\1, D1
	TRAP 	#15
	MOVEM.L	(SP)+,D0-D1
	ENDM
	
GET_CMP MACRO
	BSR 	GET_RND
	if D1 <HI> D4 then
	    MOVE.L	D1, D4
	    MOVE	#\1, D0
	endi
	ENDM
	
DRAW_LINE MACRO		;X, Y, X2, Y2
        MOVEM.L	D2,-(SP)
        MOVE.L  \1, D1
        MOVE.L  \2, D3
        MOVE.L  \3, D4
        MOVE.L  \4, D5
        BSR IN_DRAW_LINE
        MOVEM.L	(SP)+,D2
        ENDM
        
SLEEP MACRO
	MOVEM.L	D0-D2,-(SP)
	
	MOVE 	#8, D0
	TRAP 	#15
	MOVE.L	D1, D2
	ADD.L	#\1, D2
	WHILE <T> DO
	
		MOVE 	#8, D0
		TRAP 	#15

		IF D1 <GE> D2 THEN
			BRA EXIT\@
		ENDI
		NOP
		NOP
		NOP
		NOP
		NOP
	ENDW
EXIT\@
	MOVEM.L	(SP)+,D0-D2
	ENDM

*D3 = X
*D4 = Y
*D6 = X2
*D7 = Y2

DRAW_SQUARE MACRO	;WallData, XCoord, YCoord
        MOVEM.L	D0-D7,-(SP)
	MOVE	\2, D6
	MOVE	\3, D7
	MULU	#BOX_WIDTH, D6	*Store actual X coord in D7
	MULU	#BOX_WIDTH, D7	*Store actual Y coord in D8
	MOVE	D6, D3  *Set X2 to X
	MOVE	D7, D4  *Set Y2 to Y
	if \1 <GT> #7 then
		SUB	#8, \1
		ADD	#BOX_WIDTH, D7
		DRAW_LINE D3, D4, D6, D7
		SUB     #BOX_WIDTH, D7
		MOVE	D6, D3  *Set X2 to X
	        MOVE	D7, D4  *Set Y2 to Y
	endi
        if \1 <GT> #3 then
		SUB	#4, \1
		ADD	#BOX_WIDTH, D7
		ADD	#BOX_WIDTH, D3
		ADD	#BOX_WIDTH, D6
		DRAW_LINE D3, D4, D6, D7
		SUB     #BOX_WIDTH, D7
		SUB     #BOX_WIDTH, D6
	        MOVE	D6, D3  *Set X2 to X
	        MOVE	D7, D4  *Set Y2 to Y

	endi
        if \1 <GT> #1 then
		SUB	#2, \1
		ADD	#BOX_WIDTH, D6
		DRAW_LINE D3, D4, D6, D7
		SUB     #BOX_WIDTH, D6
	        MOVE	D6, D3  *Set X2 to X
	        MOVE	D7, D4  *Set Y2 to Y
	endi
	if \1 <GT> #0 then
		ADD	#BOX_WIDTH, D6
		ADD	#BOX_WIDTH, D4
		ADD	#BOX_WIDTH, D7
		DRAW_LINE D3, D4, D6, D7
		SUB     #BOX_WIDTH, D6
	        MOVE	D6, D3  *Set X2 to X
	        MOVE	D7, D4  *Set Y2 to Y
	endi		
        MOVEM.L	(SP)+,D0-D7
        
	ENDM

CLEAR_WALL MACRO

        MOVEM.L	D3-D4,-(SP)
        
	MOVE	#0, D4
	if \1 <GT> #2 then
		if \2 <GT> #7 then
			SUB	#8, \2
		endi
		BRA	RET\@
	endi
	
	if \2 <GT> #7 then
		SUB	#8, \2
		MOVE	#8, D4
	endi
	
	if \1 <GT> #1 then
		if \2 <GT> #3 then
			SUB	#4, \2
		endi
		BRA	RET\@
	endi
	
	if \2 <GT> #3 then
		SUB	#4, \2
		ADD	#4, D4
	endi
	
	if \1 <GT> #0 then
		if \2 <GT> #1 then
			SUB	#2, \2
		endi
		BRA	RET\@
	endi
	
	if \2 <GT> #1 then
		SUB	#2, \2
		ADD	#2, D4
	endi
	
	if \2 <GT> #0 then
		SUB	#1, \2
	endi
	
	
			
RET\@

	ADD	D4, \2	*Restore any remaining value
	
	*Check and see if we are hitting the left wall for the last time.
	*If we are clear the out bit
	if D7 <EQ> #MAX_X_MONE then
		MOVE.L	#0, D3
		MOVE.B	(HITWALL,PC), D3
		ADD.B	#1, D3
		MOVE.B	D3,HITWALL
		
		if D3 <EQ> #MAX_Y_MONE then
			MOVE	#0, D4
			if \2 <GE> #8 then
				ADD	#8, D4
				SUB	#8, \2
			endi
			if \2 <GE> #4 then
				SUB	#4, \2
			endi
			ADD	D4, \2
		endi
		
	endi
	
	MOVEM.L	(SP)+,D3-D4
	ENDM

CALC_COORD MACRO
        MOVE.L    #0, \3
        MOVE    \2, \3
        MULU	#MAX_X, \3
        ADD     \1, \3

        ENDM

ENABLE_BUFFER MACRO
	MOVE 	#92, D0
	MOVE	#17, D1
	TRAP 	#15

	ENDM
	
PUSH_BUFFER MACRO
	MOVE 	#94, D0
	TRAP 	#15

	ENDM

DRAW_PLAYER MACRO

	MOVEM.L	D0-D4,-(SP)
	
	*Set Player Color
	SET_COLOR #BLUE
	
	*Draw Right Leg
	MOVE.W P_X, D3
	MOVE.W P_Y, D4
	MULU	#BOX_WIDTH, D3
	MULU	#BOX_WIDTH, D4
	
	ADD	#13, D3
	ADD	#18, D4
	
	MOVE	D3, D1
	MOVE  	D4,D2         
	move.b  #86,D0
	trap    #15            

	ADD	#5, D3
	ADD	#5, D4
	
	move  D3,D1       
	move  D4,D2         
	move.b  #85,D0
	trap    #15

	*Draw Left Leg
	MOVE.W P_X, D3
	MOVE.W P_Y, D4
	MULU	#BOX_WIDTH, D3
	MULU	#BOX_WIDTH, D4
	
	ADD	#14, D3
	ADD	#18, D4
	
	MOVE	D3, D1
	MOVE  	D4,D2         
	move.b  #86,D0
	trap    #15      
      
	ADD	#5, D4
	SUB	#5, D3
	
	move  D3,D1       
	move  D4,D2         
	move.b  #85,D0
	trap    #15    


	*Draw Body
	MOVE.W P_X, D3
	MOVE.W P_Y, D4
	MULU	#BOX_WIDTH, D3
	MULU	#BOX_WIDTH, D4
	
	ADD	#14, D3
	ADD	#18, D4
	
	MOVE	D3, D1
	MOVE  	D4,D2         
	move.b  #86,D0
	trap    #15      
      
	SUB	#7, D4
	
	move  D3,D1       
	move  D4,D2         
	move.b  #85,D0
	trap    #15    
	
	
	
	*Draw Right Arm
	MOVE.W P_X, D3
	MOVE.W P_Y, D4
	MULU	#BOX_WIDTH, D3
	MULU	#BOX_WIDTH, D4
	
	ADD	#13, D3
	ADD	#16, D4
	
	MOVE	D3, D1
	MOVE  	D4,D2         
	move.b  #86,D0
	trap    #15            

	SUB	#5, D3
	SUB	#5, D4
	
	move  D3,D1       
	move  D4,D2         
	move.b  #85,D0
	trap    #15

	*Draw Left Arm
	MOVE.W P_X, D3
	MOVE.W P_Y, D4
	MULU	#BOX_WIDTH, D3
	MULU	#BOX_WIDTH, D4
	
	ADD	#14, D3
	ADD	#16, D4
	
	MOVE	D3, D1
	MOVE  	D4,D2         
	move.b  #86,D0
	trap    #15      
      
	SUB	#5, D4
	ADD	#5, D3
	
	move  D3,D1       
	move  D4,D2         
	move.b  #85,D0
	trap    #15  
	
	*Draw Head
	MOVE.W P_X, D3
	MOVE.W P_Y, D4
	MULU	#BOX_WIDTH, D3
	MULU	#BOX_WIDTH, D4
	
	ADD	#11, D3
	ADD	#5, D4
	
	MOVE	D3, D1
	MOVE  	D4, D2             
      
	ADD	#5, D4
	ADD	#5, D3
	        
	move.b  #91,D0
	trap    #15  


	MOVEM.L	(SP)+,D0-D4
	
	ENDM
	
DRAW_WIN MACRO

	MOVEM.L	D0-D2,-(SP)
	
	*Clear the Screen
        MOVE #$FF00, D1
        MOVE #11, D0
        TRAP #15

	*SET_COLOR #GREEN
	
	LEA     WIN_MSG, A1
	MOVE.W	#15,D1
	MOVE.W 	#15,D2         
	move.b  #95,D0
	trap    #15            

	PUSH_BUFFER

	MOVEM.L	(SP)+,D0-D2
	
	ENDM
	
*8 - Left Wall
*4 - Right Wall
*2 - Top Wall
*1 - Bottom Wall
	
	ORG	$1000
START:				; first instruction of program


	*Get time since midnight as the seed for the RNG.
	MOVE	#8, D0
	TRAP 	#15
	LEA	variables(pc), A3
	MOVE.L	D1, RNDSeed(A3)
	
	MOVE.W	#0, P_X
	MOVE.W	#0, P_Y
	
	SET_PEN #2
	
	SET_COLOR #RED
	
	ENABLE_BUFFER
	
	*Fill Maze Array
	*First Bit
	LEA	theMaze(pc), A1
        FOR.L D1 = #0 TO #MAZE_SIZE BY #1 DO
            MOVE.B #$0F, (A1, D1.L)
        ENDF

	BSR DRW_SCREEN
        
       
        *Generate Random Y Position to start at. Stores it into D6
        BSR GET_STR
	*D6 = Up/Down
	*D7 = Left/Right
        MOVE	#0, D7	*Start at the wall
        
        MOVE.W	D6, P_Y *Set Player Y to the starting square
        
        *Clear left wall
        MOVE	#3, D1
        MOVE.L	#0, D2
        MOVE	D6, D5
        MULU	#MAX_X, D5
        MOVE.B	(A1, D5.L), D2
        CLEAR_WALL D1, D2
        MOVE.B D2, (A1, D5.L)
        BSR DRW_SCREEN
        
        *Generate the maze
	BSR MOVE_ON
	BSR DRW_SCREEN
	
*---- main program loop ----
loop	nop 
	move.b	#7,d0					; check for pending key press
	trap	#15
	if d1 <ne> #0 then			; if key is ready

		MOVE.B #19,D0     
		MOVE.L #'A'<<24+'S'<<16+'D'<<8+'W',D1 ; check for keypress (a,s,d,w)
		TRAP   #15
		BTST.L #24,D1    
		IF <NE> THEN    *A/Left
			MOVE.W	P_X, D3
			MOVE.W	P_Y, D4
			SUB	#1, D3
			IF D3 <HS> #0 THEN
				CALC_COORD D3, D4, D5
				MOVE.B	(A1, D5.L), D2
				
				IF D2 <HS> #8 THEN
					SUB	#8, D2
				ENDI
				IF D2 <LO> #4 THEN
					MOVE.W	D3, P_X
				ENDI
			ENDI
		ENDI
		
		BTST.L #16,D1     
		IF <NE> THEN    *S/Down
			MOVE.W	P_X, D3
			MOVE.W	P_Y, D4

			ADD	#1, D4
			IF D4 <LO> #MAX_Y THEN	
				CALC_COORD D3, D4, D5
				MOVE.B	(A1, D5.L), D2
				
				IF D2 <HS> #8 THEN
					SUB	#8, D2
				ENDI
				IF D2 <HS> #4 THEN
					SUB     #4, D2
				ENDI
				IF D2 <LO> #2 THEN
				        MOVE.W	D4, P_Y
				ENDI
			ENDI
		ENDI
		
		BTST.L #8,D1  
		IF <NE> THEN    *D/Right  
			MOVE.W	P_X, D3
			MOVE.W	P_Y, D4
			ADD     #1, D3
	
			CALC_COORD D3, D4, D5
			MOVE.B	(A1, D5.L), D2
			
			IF D3 <HS> #MAX_X THEN	*Check left wall to see if we can exit
				MOVE.W	P_X, D3
				CALC_COORD D3, D4, D5
				MOVE.B	(A1, D5.L), D2
				
				IF D2 <HS> #8 THEN
					SUB	#8, D2
				ENDI
				IF D2 <LO> #4 THEN
					BRA WIN
				ENDI
			ENDI
			IF D3 <LO> #MAX_X THEN
				IF D2 <LO> #8 THEN
					MOVE.W	D3, P_X
				ENDI
			ENDI
		ENDI
		
		BTST.L #0,D1
		IF <NE> THEN	*W/Up
			MOVE.W	P_X, D3
			MOVE.W	P_Y, D4
			SUB	#1, D4	
			IF D4 <HS> #0 THEN	
				CALC_COORD D3, D4, D5
				MOVE.B	(A1, D5.L), D2
				
				IF D2 <HS> #8 THEN
					SUB	#8, D2
				ENDI
				IF D2 <HS> #4 THEN
					SUB     #4, D2
				ENDI
				IF D2 <HS> #2 THEN
				        SUB     #2, D2
				ENDI
				IF D2 <LS> #0 THEN
				        MOVE.W	D4, P_Y
				ENDI
			ENDI
		ENDI
		BSR DRW_SCREEN
		SLEEP 10
	endi
	nop
	bra	loop 

WIN:
        DRAW_WIN

        MOVE.B	#9,D0
	TRAP	#15		; halt simulator
	
*Subroutines
MOVE_ON

        BSR GET_DIR
	if D5 <NE> #$FF then
	
	        *Clear my wall in that direction
	        
	        MOVEM.L	D0-D7,-(SP)

	        MOVE.L  #0, D1
        	MOVE    D5, D1
        	MOVE.L	#0, D2
                MOVE	D6, D5
                MULU	#MAX_X, D5
                ADD     D7, D5
                MOVE.B	(A1, D5.L), D2
                CLEAR_WALL D1, D2
                MOVE.B D2, (A1, D5.L)
                
                MOVEM.L	(SP)+,D0-D7
                
	        MOVEM.L	D6-D7,-(SP)
	        
        	BSR CALC_OFFSET
        	
        	BSR OPP_DIR
        	
        	*Clear their wall in that direction
                MOVE.L  #0, D1
        	MOVE    D5, D1
        	MOVE.L	#0, D2
                MOVE	D6, D5
                MULU	#MAX_X, D5
                ADD     D7, D5
                MOVE.B	(A1, D5.L), D2
                CLEAR_WALL D1, D2
                MOVE.B D2, (A1, D5.L)
                
                
                SLEEP 1
                BSR DRW_SCREEN
                
                BSR MOVE_ON
                MOVEM.L	(SP)+,D6-D7
                BRA MOVE_ON
        endi
        
        RTS
        
NEW_LINE
	MOVEM.L	D0/A1,-(SP)
	MOVE 	#14, D0
	LEA	NEWLINE, A1
	TRAP 	#15
	MOVEM.L	(SP)+,D0/A1
	RTS
	
*Flip D5 into its opposite (used for removing the proper wall when moving into a cell)
OPP_DIR
        if D5 <EQ> #3 then
                MOVE #2, D5
                RTS
        endi
        if D5 <EQ> #2 then
                MOVE #3, D5
                RTS
        endi
        if D5 <EQ> #1 then
                MOVE #0, D5
                RTS
        endi
        
        MOVE #1, D5
        RTS


*Returns a random direction to move in
*Takes into account cells that are already used.
*Result in D5. $FF = No possible directions	
GET_DIR
	MOVEM.L	D6-D7,-(SP)
        MOVE.L #01, D4
        MOVE.L #0, D0
        MOVE   #$FF, D0
        
        MOVE #0, D5
        MOVEM.L	D6-D7,-(SP)
        BSR CALC_OFFSET
        
        if D6 <GE> #0 then
                if D6 <LT> #MAX_Y then
                        MOVE.L  #0, D2
                        MOVE.B	(A1, D3.L), D2
        
                        if D2 <EQ> #$0F then
                                GET_CMP	0
                        endi    
                endi
        endi
        
        MOVE #1, D5
        MOVEM.L	(SP)+,D6-D7
        MOVEM.L	D6-D7,-(SP)
        BSR CALC_OFFSET
        
        if D6 <GE> #0 then
                if D6 <LT> #MAX_Y then
                        MOVE.L  #0, D2
                        MOVE.B	(A1, D3.L), D2
        
                        if D2 <EQ> #$0F then
                                GET_CMP	1
                        endi    
                endi
        endi
        
        MOVE #2, D5
        MOVEM.L	(SP)+,D6-D7
        MOVEM.L	D6-D7,-(SP)
        BSR CALC_OFFSET
        
        if D7 <GE> #0 then
                if D7 <LT> #MAX_X then
                        MOVE.L  #0, D2
                        MOVE.B	(A1, D3.L), D2
        
                        if D2 <EQ> #$0F then
                                GET_CMP	2
                        endi    
                endi
        endi
        
        MOVE #3, D5
        MOVEM.L	(SP)+,D6-D7
        BSR CALC_OFFSET
        
        if D7 <GE> #0 then
                if D7 <LT> #MAX_X then
                        MOVE.L  #0, D2
                        MOVE.B	(A1, D3.L), D2
        
                        if D2 <EQ> #$0F then
                                GET_CMP	3
                        endi    
                endi
        endi
        MOVE    D0, D5
        if D0 <EQ> #$FF then
        	NOP
        endi
	MOVEM.L	(SP)+,D6-D7
	RTS

GET_STR
        MOVE.L #0, D4
        FOR.L D5 = #0 TO #MAX_Y_RND BY #1 DO
		BSR 	GET_RND
		CMP.L	D1, D4
		BLE	PASS
		MOVE.L	D1, D4
		MOVE	D5, D6
PASS
	ENDF
	RTS
	
CALC_OFFSET
        if D5 <GE> #3 then
                SUB #1, D7
                BRA CALC_OFFSET_END
        endi
        if D5 <GE> #2 then
                ADD #1, D7
                BRA CALC_OFFSET_END
        endi
        if D5 <GE> #1 then
                SUB #1, D6
                BRA CALC_OFFSET_END
        endi
        
        ADD     #1, D6
CALC_OFFSET_END
        CALC_COORD D7, D6, D3
        RTS

	
DRW_SCREEN
	*Clear the Screen
	MOVEM.L	D0-D1,-(SP)
        MOVE #$FF00, D1
        MOVE #11, D0
        TRAP #15
        MOVEM.L	(SP)+,D0-D1
        
        *Set Color for maze
        SET_COLOR #RED
        
        *Draw new screen
	FOR.L D1 = #0 TO #MAZE_SIZE BY #1 DO
		MOVE.B	(A1, D1.L), D2
		MOVE	D1, D3
		DIVU	#MAX_X, D3
		MOVE.W	D3, D4
		MOVE.W	#0, D3
		SWAP	D3	
		DRAW_SQUARE D2, D3, D4
		
        ENDF
        
        DRAW_PLAYER
        
	PUSH_BUFFER   
        RTS

*Internal SubRoutine to draw lines
*NOTE: You must recover D0-5 after calling!	
IN_DRAW_LINE       
	move.l  D3,D2         
	move.b  #86,D0
	trap    #15            

	move.l  D4,D1       
	move.l  D5,D2         
	move.b  #85,D0
	trap    #15    
	RTS

*************************************************************************************
* Random Number Generator. Code Credits Lee Davidson

*Puts the RND into D1
GET_RND
        MOVEM.L	D0,-(SP)
	BSR		IN_RNDGEN		    
	MOVE.B		RNDSeed(A3),D1
	MOVE.L D0, D1
	*BCLR #7, D1
	MOVEM.L	(SP)+,D0
	RTS
*Internal RND Code
IN_RNDGEN
	MOVE.L		RNDSeed(A3),D0		* get current seed longword
	MOVEQ		#$AF-$100,D1		* set EOR value
	MOVEQ		#18,D2			* do this 19 times
IN_RND0
	ADD.L		D0,D0			* shift left 1 bit
	BCC.S		IN_RND1			* if bit not set skip feedback

	EOR.B		D1,D0			* do Galois LFSR feedback
IN_RND1
	DBF		D2,IN_RND0		* loop

	MOVE.L		D0,RNDSeed(A3)		* save back to seed longword

	RTS


* Variables and Strings
variables				
RNDSeed	DS.L	1
NEWLINE	DC.B	10,13,0
HITWALL DC.B	0		*Used to determine the last time the wall was hit so we can create an exit
P_X	DC.W	0		*Player X/Y
P_Y	DC.W	0
WIN_MSG DC.B    'Game Over! You Win!',0

theMaze	DS.B	MAX_X*MAX_Y	*Reserve maze array
	DS.W	0

	END	START		; last line of source

*~Font name~Courier New~
*~Font size~10~
*~Tab type~1~
*~Tab size~8~
